<?php

/**
 * @package JoomShopping for Joomla!
 * @subpackage payment
 * @author YooMoney
 * @copyright Copyright (C) 2024 YooMoney. All rights reserved.
 */

namespace YooMoney\Updater\ProjectStructure;

/**
 * Интерфейс директории проекта
 *
 * @package YooMoney\Updater\ProjectStructure
 */
interface DirectoryEntryInterface extends EntryInterface
{
    /**
     * Возвращает список директорий внутри текущией директории.
     *
     * @return DirectoryEntryInterface[] Список поддиректорий
     */
    function getDirectoryEntries(): array;

    /**
     * Возвращает список файлов внутри текущей директории.
     *
     * @return FileEntryInterface[] Список файлов внутри директории
     */
    function getFileEntries(): array;
}
